require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

RSpec.describe PersonShiftsController, type: :controller do

  # This should return the minimal set of attributes required to create a valid
  # PersonShift. As you add validations to PersonShift, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) {
    skip("Add a hash of attributes valid for your model")
  }

  let(:invalid_attributes) {
    skip("Add a hash of attributes invalid for your model")
  }

  # This should return the minimal set of values that should be in the session
  # in order to pass any filters (e.g. authentication) defined in
  # PersonShiftsController. Be sure to keep this updated too.
  let(:valid_session) { {} }

  describe "GET #index" do
    it "assigns all person_shifts as @person_shifts" do
      person_shift = PersonShift.create! valid_attributes
      get :index, {}, valid_session
      expect(assigns(:person_shifts)).to eq([person_shift])
    end
  end

  describe "GET #show" do
    it "assigns the requested person_shift as @person_shift" do
      person_shift = PersonShift.create! valid_attributes
      get :show, {:id => person_shift.to_param}, valid_session
      expect(assigns(:person_shift)).to eq(person_shift)
    end
  end

  describe "GET #new" do
    it "assigns a new person_shift as @person_shift" do
      get :new, {}, valid_session
      expect(assigns(:person_shift)).to be_a_new(PersonShift)
    end
  end

  describe "GET #edit" do
    it "assigns the requested person_shift as @person_shift" do
      person_shift = PersonShift.create! valid_attributes
      get :edit, {:id => person_shift.to_param}, valid_session
      expect(assigns(:person_shift)).to eq(person_shift)
    end
  end

  describe "POST #create" do
    context "with valid params" do
      it "creates a new PersonShift" do
        expect {
          post :create, {:person_shift => valid_attributes}, valid_session
        }.to change(PersonShift, :count).by(1)
      end

      it "assigns a newly created person_shift as @person_shift" do
        post :create, {:person_shift => valid_attributes}, valid_session
        expect(assigns(:person_shift)).to be_a(PersonShift)
        expect(assigns(:person_shift)).to be_persisted
      end

      it "redirects to the created person_shift" do
        post :create, {:person_shift => valid_attributes}, valid_session
        expect(response).to redirect_to(PersonShift.last)
      end
    end

    context "with invalid params" do
      it "assigns a newly created but unsaved person_shift as @person_shift" do
        post :create, {:person_shift => invalid_attributes}, valid_session
        expect(assigns(:person_shift)).to be_a_new(PersonShift)
      end

      it "re-renders the 'new' template" do
        post :create, {:person_shift => invalid_attributes}, valid_session
        expect(response).to render_template("new")
      end
    end
  end

  describe "PUT #update" do
    context "with valid params" do
      let(:new_attributes) {
        skip("Add a hash of attributes valid for your model")
      }

      it "updates the requested person_shift" do
        person_shift = PersonShift.create! valid_attributes
        put :update, {:id => person_shift.to_param, :person_shift => new_attributes}, valid_session
        person_shift.reload
        skip("Add assertions for updated state")
      end

      it "assigns the requested person_shift as @person_shift" do
        person_shift = PersonShift.create! valid_attributes
        put :update, {:id => person_shift.to_param, :person_shift => valid_attributes}, valid_session
        expect(assigns(:person_shift)).to eq(person_shift)
      end

      it "redirects to the person_shift" do
        person_shift = PersonShift.create! valid_attributes
        put :update, {:id => person_shift.to_param, :person_shift => valid_attributes}, valid_session
        expect(response).to redirect_to(person_shift)
      end
    end

    context "with invalid params" do
      it "assigns the person_shift as @person_shift" do
        person_shift = PersonShift.create! valid_attributes
        put :update, {:id => person_shift.to_param, :person_shift => invalid_attributes}, valid_session
        expect(assigns(:person_shift)).to eq(person_shift)
      end

      it "re-renders the 'edit' template" do
        person_shift = PersonShift.create! valid_attributes
        put :update, {:id => person_shift.to_param, :person_shift => invalid_attributes}, valid_session
        expect(response).to render_template("edit")
      end
    end
  end

  describe "DELETE #destroy" do
    it "destroys the requested person_shift" do
      person_shift = PersonShift.create! valid_attributes
      expect {
        delete :destroy, {:id => person_shift.to_param}, valid_session
      }.to change(PersonShift, :count).by(-1)
    end

    it "redirects to the person_shifts list" do
      person_shift = PersonShift.create! valid_attributes
      delete :destroy, {:id => person_shift.to_param}, valid_session
      expect(response).to redirect_to(person_shifts_url)
    end
  end

end
